unit CUnit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ComCtrls, Sockets;

const
  CLIENTCONNECTED         = 1;
  CLIENTIDLE              = 0;

type

  TClientSocket = class(TAsyncSocket)
  public
    m_Status: LongInt;
    procedure OnConnect(SocketMessage: TWMSocket); override;
    procedure OnRead(SocketMessage: TWMSocket); override;
    procedure OnError(SocketMessage: TWMSocket); override;
    procedure OnClose(SocketMessage: TWMSocket); override;
    procedure SendString(fString: String);
  end;

  TForm1 = class(TForm)
    Edit1: TEdit;
    RichEdit1: TRichEdit;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Connection1: TMenuItem;
    PortNumber1: TMenuItem;
    ServerAddress1: TMenuItem;
    Connect1: TMenuItem;
    StatusBar1: TStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure PortNumber1Click(Sender: TObject);
    procedure ServerAddress1Click(Sender: TObject);
    procedure Connect1Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    m_strBuff: Array[0..2047] of Char;
    m_ClientSocket: TClientSocket;
    procedure OnIdle(Sender: TObject; var Done: Boolean);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  m_ClientSocket := TClientSocket.Create;
  m_ClientSocket.m_Status := CLIENTIDLE;
  m_ClientSocket.PortNumber := 2001;
  m_ClientSocket.IPAddress := '127.0.0.1';
  RichEdit1.Align := alClient;
  Edit1.Align := alBottom;
  Application.OnIdle := OnIdle;
end;

procedure TForm1.OnIdle(Sender: TObject; var Done: Boolean);
var
  mess: String;
  ipadd: String;
begin
  ipadd := '';
  if (m_ClientSocket.m_Status = CLIENTIDLE) then
    mess := 'Idle'
  else if (m_ClientSocket.m_Status = CLIENTCONNECTED) then
    begin
    mess := 'Connected';
    ipadd := m_ClientSocket.DoGetHostByAddr(PChar(m_ClientSocket.IPAddress));
    if (ipadd = '') then
      ipadd := m_ClientSocket.IPAddress;
    ipadd := ' to ' + ipadd;
    end;
  mess := mess + ' on port ' + IntToStr(m_ClientSocket.PortNumber) + ipadd;
  if (StatusBar1.Panels.Items[0].Text <> mess) then
    StatusBar1.Panels.Items[0].Text := mess;
  Done := TRUE;
end;

procedure TClientSocket.SendString(fString: String);
var
  tempLength: LongInt;
begin
  tempLength := Length(fString);
  DoSend(PChar(fString), tempLength);
end;

procedure TClientSocket.OnConnect(SocketMessage: TWMSocket);
begin
  m_Status := CLIENTCONNECTED;
end;

procedure TClientSocket.OnRead(SocketMessage: TWMSocket);
var
  len: LongInt;
begin
  len := SocketMessage.SocketDataSize;
  if (len < 2048) then
    begin
    ZeroMemory(@Form1.m_strBuff, 2048);
    DoReceive(@Form1.m_strBuff, len);
    Form1.RichEdit1.Lines.Add(Form1.m_strBuff);
    end
  else
    Form1.RichEdit1.Lines.Add('Message too long to receive');
end;

procedure TClientSocket.OnError(SocketMessage: TWMSocket);
begin
  DoClose;
end;

procedure TClientSocket.OnClose(SocketMessage: TWMSocket);
begin
  m_Status := CLIENTIDLE;
end;

procedure TForm1.PortNumber1Click(Sender: TObject);
begin
  try
    m_ClientSocket.PortNumber := StrToInt(InputBox('Port Number',
      'Input desired port number:', IntToStr(m_ClientSocket.PortNumber)));
  except
    Application.MessageBox('Port number must be 1-65535', 'Error', IDOK);
  end;
end;

procedure TForm1.ServerAddress1Click(Sender: TObject);
begin
    m_ClientSocket.IPAddress := InputBox('IP Address',
      'Input desired IP address:', m_ClientSocket.IPAddress);
end;

procedure TForm1.Connect1Click(Sender: TObject);
begin
  case m_ClientSocket.m_Status of
    CLIENTCONNECTED:
      m_ClientSocket.DoClose;
    CLIENTIDLE:
      m_ClientSocket.DoConnect;
  end;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
var
  mess: String;
begin
  if (Key = Char(VK_RETURN)) then
    begin
    if (m_ClientSocket.m_Status = CLIENTCONNECTED) then
      begin
      mess := Edit1.Text;
      m_ClientSocket.SendString(mess);
      end;
    Edit1.Text := '';
    Key := Char(0);
    end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  m_ClientSocket.Free;
end;

end.
